//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: crescent/liquidstaking/v1beta1/tx.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Msg defines the liquid staking Msg service.
///
/// Usage: instantiate `Crescent_Liquidstaking_V1beta1_MsgClient`, then call methods of this protocol to make API calls.
internal protocol Crescent_Liquidstaking_V1beta1_MsgClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Crescent_Liquidstaking_V1beta1_MsgClientInterceptorFactoryProtocol? { get }

  func liquidStake(
    _ request: Crescent_Liquidstaking_V1beta1_MsgLiquidStake,
    callOptions: CallOptions?
  ) -> UnaryCall<Crescent_Liquidstaking_V1beta1_MsgLiquidStake, Crescent_Liquidstaking_V1beta1_MsgLiquidStakeResponse>

  func liquidUnstake(
    _ request: Crescent_Liquidstaking_V1beta1_MsgLiquidUnstake,
    callOptions: CallOptions?
  ) -> UnaryCall<Crescent_Liquidstaking_V1beta1_MsgLiquidUnstake, Crescent_Liquidstaking_V1beta1_MsgLiquidUnstakeResponse>
}

extension Crescent_Liquidstaking_V1beta1_MsgClientProtocol {
  internal var serviceName: String {
    return "crescent.liquidstaking.v1beta1.Msg"
  }

  /// LiquidStake defines a method for performing a delegation of coins
  /// from a delegator to whitelisted validators.
  ///
  /// - Parameters:
  ///   - request: Request to send to LiquidStake.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func liquidStake(
    _ request: Crescent_Liquidstaking_V1beta1_MsgLiquidStake,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Crescent_Liquidstaking_V1beta1_MsgLiquidStake, Crescent_Liquidstaking_V1beta1_MsgLiquidStakeResponse> {
    return self.makeUnaryCall(
      path: "/crescent.liquidstaking.v1beta1.Msg/LiquidStake",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeLiquidStakeInterceptors() ?? []
    )
  }

  /// LiquidUnstake defines a method for performing an undelegation of liquid staking from a
  /// delegate.
  ///
  /// - Parameters:
  ///   - request: Request to send to LiquidUnstake.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func liquidUnstake(
    _ request: Crescent_Liquidstaking_V1beta1_MsgLiquidUnstake,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Crescent_Liquidstaking_V1beta1_MsgLiquidUnstake, Crescent_Liquidstaking_V1beta1_MsgLiquidUnstakeResponse> {
    return self.makeUnaryCall(
      path: "/crescent.liquidstaking.v1beta1.Msg/LiquidUnstake",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeLiquidUnstakeInterceptors() ?? []
    )
  }
}

internal protocol Crescent_Liquidstaking_V1beta1_MsgClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'liquidStake'.
  func makeLiquidStakeInterceptors() -> [ClientInterceptor<Crescent_Liquidstaking_V1beta1_MsgLiquidStake, Crescent_Liquidstaking_V1beta1_MsgLiquidStakeResponse>]

  /// - Returns: Interceptors to use when invoking 'liquidUnstake'.
  func makeLiquidUnstakeInterceptors() -> [ClientInterceptor<Crescent_Liquidstaking_V1beta1_MsgLiquidUnstake, Crescent_Liquidstaking_V1beta1_MsgLiquidUnstakeResponse>]
}

internal final class Crescent_Liquidstaking_V1beta1_MsgClient: Crescent_Liquidstaking_V1beta1_MsgClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Crescent_Liquidstaking_V1beta1_MsgClientInterceptorFactoryProtocol?

  /// Creates a client for the crescent.liquidstaking.v1beta1.Msg service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Crescent_Liquidstaking_V1beta1_MsgClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Msg defines the liquid staking Msg service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Crescent_Liquidstaking_V1beta1_MsgProvider: CallHandlerProvider {
  var interceptors: Crescent_Liquidstaking_V1beta1_MsgServerInterceptorFactoryProtocol? { get }

  /// LiquidStake defines a method for performing a delegation of coins
  /// from a delegator to whitelisted validators.
  func liquidStake(request: Crescent_Liquidstaking_V1beta1_MsgLiquidStake, context: StatusOnlyCallContext) -> EventLoopFuture<Crescent_Liquidstaking_V1beta1_MsgLiquidStakeResponse>

  /// LiquidUnstake defines a method for performing an undelegation of liquid staking from a
  /// delegate.
  func liquidUnstake(request: Crescent_Liquidstaking_V1beta1_MsgLiquidUnstake, context: StatusOnlyCallContext) -> EventLoopFuture<Crescent_Liquidstaking_V1beta1_MsgLiquidUnstakeResponse>
}

extension Crescent_Liquidstaking_V1beta1_MsgProvider {
  internal var serviceName: Substring { return "crescent.liquidstaking.v1beta1.Msg" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "LiquidStake":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Crescent_Liquidstaking_V1beta1_MsgLiquidStake>(),
        responseSerializer: ProtobufSerializer<Crescent_Liquidstaking_V1beta1_MsgLiquidStakeResponse>(),
        interceptors: self.interceptors?.makeLiquidStakeInterceptors() ?? [],
        userFunction: self.liquidStake(request:context:)
      )

    case "LiquidUnstake":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Crescent_Liquidstaking_V1beta1_MsgLiquidUnstake>(),
        responseSerializer: ProtobufSerializer<Crescent_Liquidstaking_V1beta1_MsgLiquidUnstakeResponse>(),
        interceptors: self.interceptors?.makeLiquidUnstakeInterceptors() ?? [],
        userFunction: self.liquidUnstake(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Crescent_Liquidstaking_V1beta1_MsgServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'liquidStake'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeLiquidStakeInterceptors() -> [ServerInterceptor<Crescent_Liquidstaking_V1beta1_MsgLiquidStake, Crescent_Liquidstaking_V1beta1_MsgLiquidStakeResponse>]

  /// - Returns: Interceptors to use when handling 'liquidUnstake'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeLiquidUnstakeInterceptors() -> [ServerInterceptor<Crescent_Liquidstaking_V1beta1_MsgLiquidUnstake, Crescent_Liquidstaking_V1beta1_MsgLiquidUnstakeResponse>]
}
