//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: osmosis/gamm/v2/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Usage: instantiate `Osmosis_Gamm_V2_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Osmosis_Gamm_V2_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Osmosis_Gamm_V2_QueryClientInterceptorFactoryProtocol? { get }

  func spotPrice(
    _ request: Osmosis_Gamm_V2_QuerySpotPriceRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Osmosis_Gamm_V2_QuerySpotPriceRequest, Osmosis_Gamm_V2_QuerySpotPriceResponse>
}

extension Osmosis_Gamm_V2_QueryClientProtocol {
  internal var serviceName: String {
    return "osmosis.gamm.v2.Query"
  }

  /// SpotPrice defines a gRPC query handler that returns the spot price given
  /// a base denomination and a quote denomination.
  ///
  /// - Parameters:
  ///   - request: Request to send to SpotPrice.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func spotPrice(
    _ request: Osmosis_Gamm_V2_QuerySpotPriceRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Osmosis_Gamm_V2_QuerySpotPriceRequest, Osmosis_Gamm_V2_QuerySpotPriceResponse> {
    return self.makeUnaryCall(
      path: "/osmosis.gamm.v2.Query/SpotPrice",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeSpotPriceInterceptors() ?? []
    )
  }
}

internal protocol Osmosis_Gamm_V2_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'spotPrice'.
  func makeSpotPriceInterceptors() -> [ClientInterceptor<Osmosis_Gamm_V2_QuerySpotPriceRequest, Osmosis_Gamm_V2_QuerySpotPriceResponse>]
}

internal final class Osmosis_Gamm_V2_QueryClient: Osmosis_Gamm_V2_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Osmosis_Gamm_V2_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the osmosis.gamm.v2.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Osmosis_Gamm_V2_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// To build a server, implement a class that conforms to this protocol.
internal protocol Osmosis_Gamm_V2_QueryProvider: CallHandlerProvider {
  var interceptors: Osmosis_Gamm_V2_QueryServerInterceptorFactoryProtocol? { get }

  /// SpotPrice defines a gRPC query handler that returns the spot price given
  /// a base denomination and a quote denomination.
  func spotPrice(request: Osmosis_Gamm_V2_QuerySpotPriceRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Osmosis_Gamm_V2_QuerySpotPriceResponse>
}

extension Osmosis_Gamm_V2_QueryProvider {
  internal var serviceName: Substring { return "osmosis.gamm.v2.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "SpotPrice":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Osmosis_Gamm_V2_QuerySpotPriceRequest>(),
        responseSerializer: ProtobufSerializer<Osmosis_Gamm_V2_QuerySpotPriceResponse>(),
        interceptors: self.interceptors?.makeSpotPriceInterceptors() ?? [],
        userFunction: self.spotPrice(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Osmosis_Gamm_V2_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'spotPrice'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeSpotPriceInterceptors() -> [ServerInterceptor<Osmosis_Gamm_V2_QuerySpotPriceRequest, Osmosis_Gamm_V2_QuerySpotPriceResponse>]
}
