//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: stride/mint/v1beta1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query provides defines the gRPC querier service.
///
/// Usage: instantiate `Stride_Mint_V1beta1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Stride_Mint_V1beta1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Stride_Mint_V1beta1_QueryClientInterceptorFactoryProtocol? { get }

  func params(
    _ request: Stride_Mint_V1beta1_QueryParamsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Stride_Mint_V1beta1_QueryParamsRequest, Stride_Mint_V1beta1_QueryParamsResponse>

  func epochProvisions(
    _ request: Stride_Mint_V1beta1_QueryEpochProvisionsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Stride_Mint_V1beta1_QueryEpochProvisionsRequest, Stride_Mint_V1beta1_QueryEpochProvisionsResponse>
}

extension Stride_Mint_V1beta1_QueryClientProtocol {
  internal var serviceName: String {
    return "stride.mint.v1beta1.Query"
  }

  /// Params returns the total set of minting parameters.
  ///
  /// - Parameters:
  ///   - request: Request to send to Params.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func params(
    _ request: Stride_Mint_V1beta1_QueryParamsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Stride_Mint_V1beta1_QueryParamsRequest, Stride_Mint_V1beta1_QueryParamsResponse> {
    return self.makeUnaryCall(
      path: "/stride.mint.v1beta1.Query/Params",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeParamsInterceptors() ?? []
    )
  }

  /// EpochProvisions current minting epoch provisions value.
  ///
  /// - Parameters:
  ///   - request: Request to send to EpochProvisions.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func epochProvisions(
    _ request: Stride_Mint_V1beta1_QueryEpochProvisionsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Stride_Mint_V1beta1_QueryEpochProvisionsRequest, Stride_Mint_V1beta1_QueryEpochProvisionsResponse> {
    return self.makeUnaryCall(
      path: "/stride.mint.v1beta1.Query/EpochProvisions",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeEpochProvisionsInterceptors() ?? []
    )
  }
}

internal protocol Stride_Mint_V1beta1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'params'.
  func makeParamsInterceptors() -> [ClientInterceptor<Stride_Mint_V1beta1_QueryParamsRequest, Stride_Mint_V1beta1_QueryParamsResponse>]

  /// - Returns: Interceptors to use when invoking 'epochProvisions'.
  func makeEpochProvisionsInterceptors() -> [ClientInterceptor<Stride_Mint_V1beta1_QueryEpochProvisionsRequest, Stride_Mint_V1beta1_QueryEpochProvisionsResponse>]
}

internal final class Stride_Mint_V1beta1_QueryClient: Stride_Mint_V1beta1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Stride_Mint_V1beta1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the stride.mint.v1beta1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Stride_Mint_V1beta1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query provides defines the gRPC querier service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Stride_Mint_V1beta1_QueryProvider: CallHandlerProvider {
  var interceptors: Stride_Mint_V1beta1_QueryServerInterceptorFactoryProtocol? { get }

  /// Params returns the total set of minting parameters.
  func params(request: Stride_Mint_V1beta1_QueryParamsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Stride_Mint_V1beta1_QueryParamsResponse>

  /// EpochProvisions current minting epoch provisions value.
  func epochProvisions(request: Stride_Mint_V1beta1_QueryEpochProvisionsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Stride_Mint_V1beta1_QueryEpochProvisionsResponse>
}

extension Stride_Mint_V1beta1_QueryProvider {
  internal var serviceName: Substring { return "stride.mint.v1beta1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "Params":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Stride_Mint_V1beta1_QueryParamsRequest>(),
        responseSerializer: ProtobufSerializer<Stride_Mint_V1beta1_QueryParamsResponse>(),
        interceptors: self.interceptors?.makeParamsInterceptors() ?? [],
        userFunction: self.params(request:context:)
      )

    case "EpochProvisions":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Stride_Mint_V1beta1_QueryEpochProvisionsRequest>(),
        responseSerializer: ProtobufSerializer<Stride_Mint_V1beta1_QueryEpochProvisionsResponse>(),
        interceptors: self.interceptors?.makeEpochProvisionsInterceptors() ?? [],
        userFunction: self.epochProvisions(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Stride_Mint_V1beta1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'params'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeParamsInterceptors() -> [ServerInterceptor<Stride_Mint_V1beta1_QueryParamsRequest, Stride_Mint_V1beta1_QueryParamsResponse>]

  /// - Returns: Interceptors to use when handling 'epochProvisions'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeEpochProvisionsInterceptors() -> [ServerInterceptor<Stride_Mint_V1beta1_QueryEpochProvisionsRequest, Stride_Mint_V1beta1_QueryEpochProvisionsResponse>]
}
